'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _utils = require('./utils');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var validResponse = { valid: true, error: undefined };

exports.default = {
  data: function data() {
    return {
      rulesDirty: false,
      rulesErrors: []
    };
  },

  props: {
    validateRulesWith: {
      type: Function
    },
    onError: {
      type: Function,
      default: function _default() {
        return function () {};
      }
    }
  },
  computed: {
    rulesValid: function rulesValid() {
      return this.rulesErrors.length <= 0;
    }
  },
  methods: {
    validateRules: function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
        var _this = this;

        var product = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.appName;
        var setRulesDirty = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
        var validationFunction, rulesErrors;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!(!this.validateRulesWith && !this.appRulesValidationWrapper)) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt('return', validResponse);

              case 2:
                if (setRulesDirty) {
                  this.rulesDirty = setRulesDirty;
                }

                if (this.rulesDirty) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt('return', validResponse);

              case 5:
                validationFunction = this.validateRulesWith || this.appRulesValidationWrapper(this.$store.state, this.$options.name);
                _context.next = 8;
                return validationFunction(product);

              case 8:
                rulesErrors = _context.sent;

                this.rulesErrors = this.componentPosibleErrors ? rulesErrors.errors.filter(function (error) {
                  return _this.componentPosibleErrors[error];
                }) : rulesErrors.errors;

                if (!(this.rulesErrors.length > 0)) {
                  _context.next = 12;
                  break;
                }

                return _context.abrupt('return', this.onError(this.rulesErrors));

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function validateRules() {
        return _ref.apply(this, arguments);
      }

      return validateRules;
    }(),
    hasRulesErrorsFor: function hasRulesErrorsFor(types) {
      var match = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      return (0, _utils.isErrorActive)(this.rulesErrors, types, match);
    }
  }
};